<template>
                         <div class="card bloc-analyse ">
                        <div class="card-header pl-1">
                            <div class="card-title d-flex align-content-center align-items-center " >
                                  <h3 class="card-title d-flex align-items-center pl-0 "><i style="font-size:30px" class="las la-chart-pie"></i></h3>
                      
                               <div class="input-group  mr-sm-2 ml-1" style="flex:1">
                                <div class="input-group-prepend">
                                    <div class="input-group-text"><i class="las la-car"></i></div>
                                </div>
                                <select class="form-control"  name="" @change="filtreVehiculeEvent">
                                    <option value="" >Toutes les voitures</option>
                                    <option :value="v.id" v-for="(v,key) in resources.vehicules" :key="key" >{{ v.libelle | ucFirst}}</option>
                                </select>
                            </div>
                            </div>

                            <div class="card-tools d-flex align-items-center justify-content-end ">
                            <vc-date-picker v-if="!showMonthYear" :columns="$screens({ default: 1, lg: 2 })"  :input-props="{placeholder:'Période de la courbe',class:'vc-appearance-none vc-text-base vc-text-gray-800 vc-bg-white vc-border vc-border-gray-400 vc-rounded vc-py-2 vc-px-3 vc-leading-tight focus:vc-outline-none focus:vc-shadow'}"   @input="datepickerEvent" :masks="mask" mode="range" v-model="periode" class="ml-1 vc-datep"></vc-date-picker>
                            <div v-if="showMonthYear" class="custom-control custom-checkbox">
                            <input @change="sinceEvent" type="checkbox" class="custom-control-input" id="customCheck1" v-model="params.since">
                            <label class="custom-control-label" for="customCheck1">Inclure la 1ère Transaction</label>
                          </div>
                            <select @change="anneeEvent" class="form-c-inline ml-1 " v-if="showMonthYear" v-model="params.annee">
                                <option value="2020"><strong> 2020</strong></option>
                                <option value="2019"><strong> 2019</strong></option>
                                <option value="2018"><strong> 2018</strong></option>
                            </select>
                            <button v-show="true"  type="button" class="btn btn-secondary mr-1 ml-1" @click=" showMonthYear=!showMonthYear"><i class="las la-exchange-alt"></i></button>

                            </div>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body p-0" style="display: block;">
                          <ul class="nav nav-tabs" id="custom-content-above-tab" role="tablist">
                            <li class="nav-item">
                                <a @click.prevent="update" class="nav-link active" id="courbe-tab" data-toggle="pill" href="#courbe" role="tab" aria-controls="courbe" aria-selected="true">Chiffre d'Affaire</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link" id="empile-tab" data-toggle="pill" href="#empile" role="tab" aria-controls="empile" aria-selected="false">Flux financiers</a>
                            </li>
                        </ul>
                        <div class="tab-content" id="custom-content-above-tabContent">
                          <div class="tab-pane fade pt-3 pb-3 show active" id="courbe" role="tabpanel" aria-labelledby="courbe-tab">
                                       <div class="d-flex p-4 pb-2 chiffre-line">
                                        <p class="d-flex flex-column">
                                            <span>TOTAL DU CHIFFRE D'AFFAIRE</span>
                                            <span class="text-bold text-lg">{{ ca | monnaie }}  <small>F cfa</small></span>
                                            
                                        </p>
                                        <p class="ml-auto d-flex flex-column text-right " v-if="false">
                                            <span class="text-success">
                                                          <i class="fas fa-arrow-up"></i> 12.5%
                                                        </span>
                                            <span class="text-muted">Depuis la semaine dernière</span>
                                        </p>
                                    </div>
                                    <line-chart ref="ln" v-if="loaded && showLineChart" :height='400' :chart-data="datacollection" :options="options"></line-chart>
                                    <div style="" v-if="loaded && !showLineChart">
                                      <div class="text-center no-variations-chart" style="">
                                          <p ><span class="icon-image" ><i class="las la-chart-line"></i></span></p>
                                                                                    <p class="text-center pb-0 mt-4 " style="">
                                                <span>
                                                    Aucune donnée trouvée pour <span v-if="periodIsActive"> la période du <b class="ml-1">{{ params.filter_date_dbt | toDate}} </b> au <b> {{ params.filter_date_fin_prev | toDate}}  </b></span>
                                                                               <span v-if="!periodIsActive && !params.since"> l'année <b class="ml-1">{{ params.annee }}  </b></span>
                                                                                <span v-if="!periodIsActive && params.since"> la période </span>
                                                </span>
                                          </p>
                                          <hr data-content="OU" class="hr-text width-60">
                                          <p class="text-center " style=""><span>
                                                     <span > {{ vehicule ? "La  voiture " : "Toutes les voitures "}} <b class="ml-1 text-capitalize">{{ vehicule.libelle}}</b> {{ vehicule ? " a " : " ont "}} des valeurs nulles ou indisponibles à tout instant de la période selectionnée</span>
                                                  </span>
                                          </p>
                                      </div>
                                  </div>
                          </div>
                          <div class="tab-pane fade pt-3 pb-3" id="empile" role="tabpanel" aria-labelledby="empile-tab">
                                    <div class="chiffre-bar d-flex p-4 pb-2 justify-content-between">
                                        <p class="d-flex flex-column">
                                            <span>TOTAL DU CHIFFRE D'AFFAIRE</span>
                                            <span class="text-bold text-lg">{{ bar_ca | monnaie }}  <small>F cfa</small></span>
                                            
                                        </p>
                                        <p class="d-flex flex-column">
                                            <span class="text-uppercase">total des entrées</span>
                                            <span class="text-bold text-lg">{{ bar_entree | monnaie }}  <small>F cfa</small></span>
                                        </p>
                                        <p class="d-flex flex-column">
                                            <span class="text-uppercase">total des sorties</span>
                                            <span class="text-bold text-lg">{{ bar_depense | monnaie }}  <small>F cfa</small></span>
                                        </p>
                                    </div>
                                 
                                 <bar-chart ref="lnx" v-if="loaded && showBarChart" :height='450' :chart-data="bar.datacollection" :options="bar.options"></bar-chart>
                                 <div class="" v-if="loaded && !showBarChart" >
                                    <div style="">
                                      <div class="text-center no-variations-chart" style="">
                                          <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" width="190" height="150" viewBox="0 0 20 20" class="folder-empty-state themed mt-5 pt-3 fill-color fill-opacity">
                                          <path fill="#0061d5" class="fill-color" d="M17.5 20h-16c-0.827 0-1.5-0.673-1.5-1.5v-16c0-0.827 0.673-1.5 1.5-1.5h16c0.827 0 1.5 0.673 1.5 1.5v16c0 0.827-0.673 1.5-1.5 1.5zM1.5 2c-0.276 0-0.5 0.224-0.5 0.5v16c0 0.276 0.224 0.5 0.5 0.5h16c0.276 0 0.5-0.224 0.5-0.5v-16c0-0.276-0.224-0.5-0.5-0.5h-16z"/>
                                          <path  fill="#0061d5" class="fill-color" d="M6.5 17h-2c-0.276 0-0.5-0.224-0.5-0.5v-9c0-0.276 0.224-0.5 0.5-0.5h2c0.276 0 0.5 0.224 0.5 0.5v9c0 0.276-0.224 0.5-0.5 0.5zM5 16h1v-8h-1v8z"/>
                                          <path fill="#0061d5" class="fill-color" d="M10.5 17h-2c-0.276 0-0.5-0.224-0.5-0.5v-12c0-0.276 0.224-0.5 0.5-0.5h2c0.276 0 0.5 0.224 0.5 0.5v12c0 0.276-0.224 0.5-0.5 0.5zM9 16h1v-11h-1v11z"/>
                                          <path fill="#0061d5" class="fill-color" d="M14.5 17h-2c-0.276 0-0.5-0.224-0.5-0.5v-5c0-0.276 0.224-0.5 0.5-0.5h2c0.276 0 0.5 0.224 0.5 0.5v5c0 0.276-0.224 0.5-0.5 0.5zM13 16h1v-4h-1v4z"/>
                                          </svg>
                                          <p class="text-center pb-0 mt-4 " style="">
                                                <span>
                                                    Aucune donnée trouvée pour <span v-if="periodIsActive"> la période du <b class="ml-1">{{ params.filter_date_dbt | toDate}} </b> au <b> {{ params.filter_date_fin_prev | toDate}}  </b></span>
                                                                               <span v-if="!periodIsActive && !params.since"> l'année <b class="ml-1">{{ params.annee }}  </b></span>
                                                                                <span v-if="!periodIsActive && params.since"> la période </span>
                                                </span>
                                          </p>
                                          <hr data-content="OU" class="hr-text width-60">
                                          <p class="text-center " style=""><span>
                                                     <span > {{ vehicule ? "La  voiture " : "Toutes les voitures "}} <b class="ml-1 text-capitalize">{{ vehicule.libelle}}</b> {{ vehicule ? " a " : " ont "}} des valeurs nulles ou indisponibles à tout instant de la période selectionnée</span>
                                                  </span>
                                          </p>
                                      </div>
                                    </div>
                                 </div>
                          </div>
                      </div>

                        </div>
                        <!-- /.card-footer -->
                    </div>
</template>
<script>
  import LineChart from './LineChart.js'
  import BarChart from './BarChart.js'
  export default {
    components: {
      LineChart,BarChart 
    },
    data () {
      return {
         //Liste des voitures
       resources : { vehicules :[],data:[],bars:""},
       datasets:[],
       datasetsBar:[],
       labels:[],
            mask:{

          input: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
          data: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
        },
        periode:"",
                vehicule:'',
            options: {
      responsive: true,
      
      maintainAspectRatio: false
    },
    bar:{
        datacollection: {
				labels: [],
				datasets: [
                    {
                      label: 'Data One',
                      backgroundColor: '#f87979',
                      pointBackgroundColor: 'white',
                      borderWidth: 1,
                      pointBorderColor: '#249EBF',
                      data: [ [40,30,20], 20, 30, 50, 90, 10, 20, 40, 50, 70, 90, 100]
                    }
          ]
			},
			options: {
				scales: {
					yAxes: [{
						ticks: {
							beginAtZero: true
						},
						gridLines: {
							display: true
						}
					}],
					xAxes: [{
						ticks: {
							beginAtZero: true
						},
						gridLines: {
							display: false
						}
					}]
				},
				legend: {
					display: false
				},
				tooltips: {
					enabled: true,
					mode: 'single',
					callbacks: {
						label: function(tooltipItems, data) {
							return '$' + tooltipItems.yLabel;
						}
					}
				},
				responsive: true,
				maintainAspectRatio: false,
				height: 200
             }
		
    },
    loaded:false,
        datacollection: null,
        showMonthYear:true,
        months:moment.monthsShort(),
        params:{
                  filter:"",
                  filter_date_fin_prev:"",
                  filter_date_dbt:"",
                  type:'',
                  since:false,
                  vehicule_id:"",
                  annee:moment().year(),
                  mois:moment().month()+1,
        },
      }
    },
    created()
    {
       this.initPeriode()
       this.getData()
       this.fetch()
    },
     async mounted () {
     

    },
    computed:{
        labelsForBars()
        {
            if(isDefined(this.resources.bars))
             return []
             else
             {
               return this.resources.bars.map( it => {return it.libelle})
             }        
        },
        ca()
        {
             if(this.resources.data.length> 0)
             {
                var total =  this.resources.data.reduce((item,result) => {
                       return  { montant : Number(result.montant)  + Number(item.montant) }
                 })

                 return total.montant
             }
             else
             {
               return 0
             }
        },
        bar_ca()
        {
           if(this.resources.bars.length> 0)
             {
                var total = 0
                this.resources.bars.forEach((item) => 
                {
                       console.log("Nombre ditenerance ");
                       total = Number(total) + Number(item.result)
                 })

                 return total
             }
             else
             {
               return 0
             }
        },
        bar_entree()
        {
           if(this.resources.bars.length> 0)
             {
                var total = 0
                this.resources.bars.forEach((item) => 
                {
                       total = Number(total) + Number(item.entree)
                 })

                 return total
             }
             else
             {
               return 0
             }
        },
        bar_depense()
        {
             if(this.resources.bars.length> 0)
             {
                var total = 0
                this.resources.bars.forEach((item) => 
                {
                       total = Number(total) + Number(item.sortie)
                 })

                 return total
             }
             else
             {
               return 0
             }
        },
        showBarChart()
        {
             if(this.resources.bars.length> 0 && isDefined(this.resources.bars))
             {
                 return true
             }
             return false
        },
        showLineChart()
        {
          var check = false 
             if(this.resources.data.length> 0)
             {
               return true
                // this.resources.data.forEach((item) => {
                  
                //   if(item.montant!=0)
                //    check = true
                // })
             }
             return check
        },
        periodIsActive()
        {
           return isDefined(this.params.filter_date_fin_prev) && isDefined(this.params.filter_date_dbt) ? true :false
        },
        get()
        {
          return '/api/graphs/chiffre_affaire?filter='+this.params.filter+
          '&filter_date_fin_prev='+this.params.filter_date_fin_prev+'&filter_date_dbt='
          +this.params.filter_date_dbt+'&vehicule_id='+this.params.vehicule_id+
          '&annee='+this.params.annee+'&mois='+this.params.mois+'&since='+this.params.since
        }
    },
    methods: {
        fillDataSet()
        {
              this.datasets = []
              this.datasetsBar = []
                //   this.datasetsBar.push(
                //  {
                //       label: "Résultat",
                //       backgroundColor: '#007bff',
                //       pointBackgroundColor: 'white',
                //       borderWidth: 1,
                //       pointBorderColor: '#007bff',
                //       data: this.resources.bars.map( it => {return it.result})
                //     }
                //  ),
                  this.datasetsBar.push(
                 {
                      label: "Entrée",
                      backgroundColor: '#38cebe',
                      borderColor    : '#38cebe',
                      pointBackgroundColor: 'white',
                      borderWidth: 1,
                      pointBorderColor: '#38cebe',
                      data: isDefined(this.resources.bars) ? this.resources.bars.map( it => {return it.entree}) : []
                    }
                 ),
                  this.datasetsBar.push(
                 {
                      label: "Sortie",
                      backgroundColor: '#f87979',
                      pointBackgroundColor: 'white',
                      borderWidth: 1,
                      pointBorderColor: '#249EBF',
                      data: isDefined(this.resources.bars) ? this.resources.bars.map( it => {return it.sortie}) : []
                    }
                 )
                 this.datasets.push(
                 {
                    label: !isDefined(this.params.vehicule_id) ? "Toutes les voitures" : this.vehicule.libelle,
                    backgroundColor: 'transparent',
                    borderColor:"#90969a",
                    data: this.resources.data.map( it => {return it.montant})
                    }
                 )
                     
            },
      fillData () {
         this.fillDataSet()
        this.datacollection = 
        {
          labels: this.resources.data.map( it => {return it.month.toUpperCase()}),
          datasets: this.datasets
        }

        this.bar.datacollection =
        {
          labels : isDefined(this.resources.bars) ? this.resources.bars.map( it => {return it.libelle}) : [],
          datasets: this.datasetsBar
        }
      },
      getRandomInt () {
        return Math.floor(Math.random() * (50 - 5 + 1)) + 5
      },
      
            datepickerEvent(periode)
            {
                 this.params.filter_date_dbt = moment(periode.start).format('YYYY-MM-DD')
                 this.params.filter_date_fin_prev = moment(periode.end).format('YYYY-MM-DD')
                 Vue.nextTick( () => this.getData())
            },
            sinceEvent(e)
            {
                 
                // Vue.nextTick( () => this.$refs.vuetable.refresh())
                this.getData();
            },
            anneeEvent(e)
            {
                 this.params.annee = e.target.value
                // Vue.nextTick( () => this.$refs.vuetable.refresh())
                this.getData();
            },
            moisEvent(e)
            {
                 this.params.mois = e.target.value
                 //Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            filtreVehiculeEvent(e)
            {
                 this.params.vehicule_id = e.target.value
                 this.vehicule= isDefined(this.params.vehicule_id) ? this.resources.vehicules.find( v => { return v.id == this.params.vehicule_id }): ""
                 this.getData();

            },
              filtreTypeEvent(e)
            {
                 this.params.type = e.target.value
                // Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
             fetch()
            {
                axios.get("/api/dispatcher/options/flux-finances").then((response) =>
                    {
                        this.resources.vehicules = response.data.vehicules;
                        
                        this.loaded = true

                        this.fillData()
                        window.event.$emit('ca-graph-loaded')

                    },
                    (error) =>
                    {
                        this.isLoading = false
                    });
            },
            update()
            {
                this.getData()
                this.$forceUpdate()
            },
            getData()
            {
                var vm = this
              axios.get(this.get).then((response) =>
                    {
                       this.resources.data = response.data.ca;
                       this.resources.bars = response.data.bars;

                       if(this.loaded)
                       {  
                           this.fillData()
                       }
                    },
                    (error) =>
                    {
                        this.isLoading = false
                    });
            },
        initPeriode()
        {
          var now  = moment();
        var end = moment().subtract(3,'months')

          this.periode =
          {
            start:end.toDate(),
            end:now.toDate()
          }
        }
    },
    watch: {
  showMonthYear (value) {
       if(value)
       {
         this.params.filter_date_dbt=""
         this.params.filter_date_fin_prev=""
         this.params.since=false
         this.params.annee=moment().year(),
         this.getData();
       }
       else
       {
           this.initPeriode()
           this.params.filter_date_dbt = moment(this.periode.start).format('YYYY-MM-DD')
           this.params.filter_date_fin_prev = moment(this.periode.end).format('YYYY-MM-DD')
           this.params.since=false
           this.params.annee=""

       }
  }
}
    
  }
</script>
<style>
#line-chart,#bar-chart
{
  height: 400px !important;
}

  .vc-datep .vc-w-full {
    width: auto !important;
}
.bloc-analyse .card-header > .card-tools {
   min-width: 300px;
}
.form-c-inline
{

    height: calc(2.25rem + 2px);
    padding: 0.375rem 0.75rem;
    font-size: 1rem;
    font-weight: 400;
    line-height: 1.5;
    color: #495057;
    background-color: #ffffff;
    background-clip: padding-box;
    border: 1px solid #ced4da;
    border-radius: 0.25rem;
    box-shadow: inset 0 0 0 rgba(0, 0, 0, 0);
    -webkit-transition: border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out;
    transition: border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out;
}
.no-variations-chart
{
  height: 400px;
  
}
.no-variations-chart .hr-text
{
  width: 40%;
  
}
.no-variations-chart .icon-image
{
  font-size: 150px;
  color: #6c757d;
  
}
</style>